#strict

private func Initialize() {
  local fClickable;
  fClickable = true;
  local lPicture; // -1: nicht zugeorndet; 0..x: Motiv
  lPicture = -1;
  local lState;   // Verdeckt (false) oder offen (true)
  lState = false;
  local lRotation;
  return(1);
}

private func SetPicture(iIndex) {
  return(lPicture = iIndex);
}

private func IsClickable() { return(fClickable); }
private func GetPicture() { return(lPicture); }
private func GetState() { return(lState); }

private func TurnAround(fWithRndDelay) {
  if(lPicture == -1) {
    // Sollte niemals passieren
    Log("Assertion failure: TurnAround() in _CRD");
    return(0);
  }
  fClickable = false;
  local iTurnStep, iStepSize, iStopAt;
  iStepSize = 40;
  iStopAt = 480;
  iTurnStep = 0;
  if(fWithRndDelay) {
    AddEffect("TurnDelay", this(), 200, 1, this(), GetID());
  } else {
    AddEffect("Turn", this(), 200, 1, this(), GetID());
  }
  return(1);
}

protected func FxTurnDelayStart() {
  local iWaiting;
  iWaiting = 20 + Random(20); // So 1 bis 2 Sekunden vielleicht...
  return(1);
}

protected func FxTurnDelayTimer() {
  iWaiting--;
  if(!iWaiting) {
    AddEffect("Turn", this(), 200, 1, this(), GetID());
    return(-1);
  }
  return(1);
}

protected func FxTurnStart() {
  // Workaround: SetObjDrawTransform geht nicht bei gedrehten Objekten
  lRotation = GetR();
  SetR(0);
  return(1);
}

protected func FxTurnTimer() {
  var x = iTurnStep += iStepSize;
  SetObjDrawTransform(1000 - x, -x, 0, -x, 1000 - x, 0, this());
  if(x == iStopAt) return(-1);
  return(1);
}

protected func FxTurnStop() {
  if(iStopAt == 480) {
   iStopAt = 0;
   iStepSize = -40;
   iTurnStep = 480;
   lState = !lState;
   if(lState) {
     SetGraphics(Format("%d", lPicture));
   } else {
     SetGraphics(0);
   }
   AddEffect("Turn", this(), 200, 1, this(), GetID());
   return(1);
  }
  SetR(lRotation);
  if(pCard1 && pCard2) {
    if(pCard1 -> GetState() && pCard2 -> GetState()) {
      DoWealth(iCurrentPlayer, 1);
      DoScore(iCurrentPlayer, -1);
      if(pCard1 -> GetPicture() == pCard2 -> GetPicture()) {
        Sound("Pair");
        AddEffect("Disappear", pCard1, 200, 1, pCard1, GetID());
        AddEffect("Disappear", pCard2, 200, 1, pCard2, GetID());
        pCard1 = 0;
        pCard2 = 0;
      } else {
        Sound("NoPair");
        iCurrentPlayer = (iCurrentPlayer + 1) % GetPlayerCount();
        if(GetPlayerCount() > 1)
          pCursor -> AssignControl(iCurrentPlayer);
        pCard1 -> TurnAround(true);
        pCard2 -> TurnAround(true);
        pCard1 = 0;
        pCard2 = 0;
      }
    } else {
      iGameState = 1;
    }
  } else {
    fClickable = true;
  }
  if(!(pCard1 || pCard2)) {
    iGameState = 1;
  }
  return(1);
}

protected func FxDisappearStart() {
  local lCon;
  lCon = 100;
  return(1);
}

protected func FxDisappearTimer() {
  SetR(GetR() + 20);
  DoCon(-5);
  if(GetCon() <= 5) return(-1); // Damit die Stop-Funktion auch aufgerufen wird
  return(1);
}

protected func FxDisappearStop() {
  DoScore(iCurrentPlayer, 1);
  iGameState = 1;
  RemoveObject();
}