#strict

private func Initialize() {
  SetAction("Controlling");
  static pController; // Clonk des aktuell kontrollierenden Spielers
  local iX, iY; // Koordinaten auf dem Spielfeld
  static iMx, iMy; // Bewegungskoeffizienten
  static iBx, iBy; // Bewegungskoeffizientenenden
  static iCursorAlpha; // Transparenz beim Aus- und einblenden
  local iMinX, iMinY, iMaxX, iMaxY; // Spielfeldenden
  iX = 0;
  iY = 0;
  iMinX = 0;
  iMinY = 0;
  iMaxX = 8;
  iMaxY = 4;
  return(1);
}

protected func ForceCoordinates(iPosX, iPosY) {
  iX = iPosX;
  iY = iPosY;
  return(1);
}

protected func EvaluateCommand() {
  if(iGameState == 0) RefreshGamePreview();
  return(1);
}

protected func AssignControlIntern(iPlr) {
  pController = GetHiRank(iPlr);
  pCursor -> SetOwner(iPlr);
  if(iGameState == 0) return(1);
  if(Global(iPlr)) { // Spieler benutzt Maussteuerung
    pCursor -> SetVisibility(VIS_God);
  } else {
    pCursor -> SetVisibility(VIS_Owner & VIS_God);
  }
}

protected func AssignControl(iPlr) {
  if(!GetPlayerName(iPlr)) return(0);
  if(iGameState == 1) {
    iGameState = -1;
    AddEffect("CursorFadeOut", pCursor, 1, 1, 0, GetID(), pCursor);
  } else {
    AssignControlIntern(iPlr);
  }
}

protected func GoLeft() {
  if(iGameState == -1) return(0);
  if(iX == iMinX) return(0);
  if(iGameState == 0) {
    SetPosition(GetX() - 52, GetY());
  } else {
    iGameState = -1;
    iMx = -8;
    iMy = 0;
    AddEffect("CursorMove", pCursor, 1, 1, 0, GetID(), pCursor);
  }
  iX--;
  EvaluateCommand();
  return(1);
}

protected func GoRight() {
  if(iGameState == -1) return(0);
  if(iX == iMaxX) return(0);
  if(iGameState == 0) {
    SetPosition(GetX()+52,GetY());
  } else {
    iGameState = -1;
    iMx = 8;
    iMy = 0;
    AddEffect("CursorMove", pCursor, 1, 1, 0, GetID(), pCursor);
  }
  iX++;
  EvaluateCommand();
  return(1);
}

protected func GoUp() {
  if(iGameState == -1) return(0);
  if(iY == iMinY) return(0);
  if(iGameState == 0) {
    SetPosition(GetX(),GetY()-52);
  } else {
    iGameState = -1;
    iMx = 0;
    iMy = -8;
    AddEffect("CursorMove", pCursor, 1, 1, 0, GetID(), pCursor);
  }
  iY--;
  EvaluateCommand();
  return(1);
}

protected func GoDown() {
  if(iGameState == -1) return(0);
  if(iY == iMaxY) return(0);
  if(iGameState == 0) {
    SetPosition(GetX(),GetY()+52);
  } else {
    iGameState = -1;
    iMx = 0;
    iMy = 8;
    AddEffect("CursorMove", pCursor, 1, 1, 0, GetID(), pCursor);
  }
  iY++;
  EvaluateCommand();
  return(1);
}

protected func FadeOut() {
 AddEffect("CursorFadeOut", pCursor, 1, 1, 0, GetID(), pCursor);
 iCurrentPlayer = -1;
}

protected func FxCursorFadeOutStart(pTarget, iEffectNumber) {
  iCursorAlpha = 0;
  return(1);
}

protected func FxCursorFadeOutTimer(pTarget, iEffectNumber) {
  iCursorAlpha += 15;
  iCursorAlpha = BoundBy(iCursorAlpha, 0, 255);
  SetClrModulation(RGBa(255, 255, 255, iCursorAlpha), pCursor);
  if(iCursorAlpha == 255) return(-1);
  return(1);
}

protected func FxCursorFadeOutStop(pTarget, iEffectNumber) {
  if(iCurrentPlayer == -1) return(1);
  AssignControlIntern(iCurrentPlayer);
  AddEffect("CursorFadeIn", pCursor, 1, 1, 0, GetID(), pCursor);
}

protected func FxCursorFadeInStart(pTarget, iEffectNumber) {
  iCursorAlpha = 255;
  return(1);
}

protected func FxCursorFadeInTimer(pTarget, iEffectNumber) {
  iCursorAlpha -= 15;
  iCursorAlpha = BoundBy(iCursorAlpha, 0, 255);
  SetClrModulation(RGBa(255, 255, 255, iCursorAlpha), pCursor);
  if(iCursorAlpha == 0) return(-1);
  return(1);
}

protected func FxCursorMoveStart(pTarget, iEffectNumber) {
  iBx = 48;
  iBy = 48;
  return(1);
}

protected func FxCursorMoveTimer(pTarget, iEffectNumber) {
  iBx -= Abs(iMx);
  iBy -= Abs(iMy);
  pCursor -> SetPosition(GetX(pCursor) + iMx, GetY(pCursor) + iMy);
  if((iBx <= 0) || (iBy <= 0)) return(-1);
  return(1);
}

protected func FxCursorMoveStop(pTarget, iEffectNumber) {
  iGameState = 1;
  pCursor -> SetPosition(GetX(pCursor) + iMx / 2, GetY(pCursor) + iMy / 2);
  return(1);
}

protected func FxCursorUnGrabDelayTimer() {
  pCursor -> SetGraphics(0);
  return(-1);
}

protected func DoActivate() {
  if(iGameState == -1) return(0);
  if(iGameState == 0) {
   iMinX = 0;
   iMinY = 0;
   iMaxX = iX;
   iMaxY = iY;
   iX = 0;
   iY = 0;
   SetPosition(100, 75);
   iGameState = -1;
   DisplayMessage("None");
   AddEffect("CardsFadeIn", 0, 150, 1, 0, GetID());
   return(1);
  }
  if(iGameState == 1) {
    if(card = FindObject(_CRD, -25, -25, 50, 50, 0)) {
      if(!(card -> IsClickable())) return(0);
    }
    if(pCard2) return(0);
    SetGraphics("Grab");
    AddEffect("CursorUnGrabDelay", pCursor, 1, 10, 0, GetID(), pCursor);
    var card;
    if(card = FindObject(_CRD, -25, -25, 50, 50, 0)) {
      if(!(card -> GetState())) {
        card -> TurnAround();
        if(!pCard1) {
          pCard1 = card;
        } else {
          pCard2 = card;
          //iGameState = -1;
        }
      }
    }
    return(1);
  }
}

protected func FxCardsFadeInStart(pTarget, iEffectNumber) {
  EffectVar(0, 0, iEffectNumber) = 127;
  return(1);
}

protected func FxCardsFadeInTimer(pTarget, iEffectNumber) {
  EffectVar(0, 0, iEffectNumber) -= 5;
  if(EffectVar(0, 0, iEffectNumber) < 0) EffectVar(0, 0, iEffectNumber) = 0;
  var card;
  while(card = FindObject(_CRD, 0, 0, 0, 0, 0, 0, 0, 0, card)) {
    SetClrModulation(RGBa(255, 255, 255, EffectVar(0, 0, iEffectNumber)), card);
  }
  if(EffectVar(0, 0, iEffectNumber) == 0) return(-1);
  return(1);
}

protected func FxCardsFadeInStop(pTarget, iEffectNumber) {
  iGameState = 1;
  return(1);
}

