/*-- -*-  Memory  -*- --*/

#strict

protected func Initialize() {
  static iGameWidth, iGameHeight;
  static pCursor;
  static iGameState;
  static pCard1, pCard2;
  static iCurrentPlayer;
  static iCardsCount;
  iGameWidth = 9;
  iGameHeight = 5;
  iGameState = 0;
  iCurrentPlayer = 0;
  pCursor = CreateObject(_CUR);
  pCursor -> SetPosition(100, 75);
  pCursor -> SetVisibility(VIS_None);

  ScriptGo(1);
  return(1);
}

protected func InitializePlayer(iPlr) {
  SetFoW(0, iPlr);
  Global(iPlr) = 0;
  return(1);
}

global func RefreshGamePreview() {
  if(iGameState != 0) {
    Log("Assertion failure: RefreshGamePreview()");
    return(0);
  }
  RemoveAll(_CRD);
  for(var i = 0; i <= LocalN("iX", pCursor); i++) {
    for(var j = 0; j <= LocalN("iY", pCursor); j++) {
      var card = CreateObject(_CRD, 100 + 52 * i - GetX(), 100 + 52 * j - GetY());
      SetClrModulation(RGBa(255, 255, 255, 128), card);
      SetR(-3 + (3 * (i + 5) * (j + 5)) % 7, card);
    }
  }
  if(((LocalN("iX", pCursor) + 1) * (LocalN("iY", pCursor) + 1)) % 2) {
   var pCard = FindObject(_CRD, 75 + 52 * (LocalN("iX", pCursor) / 2) - GetX(), 75 + 52 * (LocalN("iY", pCursor) / 2) - GetY(), 50, 50);
   if(pCard) RemoveObject(pCard);
  }
}

protected func AssignCards() {
  var iCount = ObjectCount(_CRD);
  for(var i = 0; i <= 49; i++) {
    Var(i) = 0;
  }
  var iCountRemaining = 50;
  for(i = 0; i < iCount; i += 2) {
    var iMyCard = Random(iCountRemaining);
    while(Var(iMyCard) == 2) iMyCard = (iMyCard + 1) % iCountRemaining;
    Var(iMyCard) = 2;
    iCountRemaining--;
  }
  var pCard;
  iCountRemaining = iCount;
  var iCurIndex = 0;
  while(pCard = FindObject(_CRD, 0, 0, 0, 0, 0, 0, 0, 0, pCard)) {
    iCurIndex = Random(50);
    while(Var(iCurIndex) == 0) iCurIndex = (iCurIndex + 3) % 50;
    Var(iCurIndex)--;
    pCard -> SetPicture(iCurIndex);
  }
  return(1);
}

func Script0() {
  LocalN("iX", pCursor) = 1;
  LocalN("iY", pCursor) = 1;
  LocalN("iMinX", pCursor) = 1;
  LocalN("iMinY", pCursor) = 1;
  pCursor -> AssignControl(0); // Spieler 1 stellt ein
  RefreshGamePreview();
  DisplayMessage("GameSize");
  return(1);
}

func Script1() {
  if(iGameState == 0) return(goto(1));
  return(1);
}

func Script2() {
  pCursor -> AssignControl(0);
  AssignCards();
  iCardsCount = ObjectCount(_CRD);
}

func Script3() {
  DisplayMessage("PlayersTurn");
  if(ObjectCount(_CRD) == 0) return(goto(4));
  return(goto(3));
}

func Script4() {
  if(ObjectCount(_CRD) != 0) return(goto(3));
  Sound("Applause");
  if(GetPlayerCount() == 1) {
    var iBetter;
    var iBest = GetPlrExtraData(iCurrentPlayer, Format("3XMry_%d", iCardsCount));
    if((GetWealth(iCurrentPlayer) < iBest) || (iBest == 0)) { iBetter = 1; }
    if(GetWealth(iCurrentPlayer) == iBest) { iBetter = 0; }
    if((GetWealth(iCurrentPlayer) > iBest) && (iBest > 0)) { iBetter = -1; }
    if(iBetter == 1) SetPlrExtraData(iCurrentPlayer, Format("3XMry_%d", iCardsCount), GetWealth(iCurrentPlayer));
    DisplayMessage("Summary", iCardsCount, GetWealth(iCurrentPlayer), iBetter, iBest);
  } else {
    var iTopScore = 0;
    for(var i = 0; i < GetPlayerCount(); i++)
      if(GetScore(i) + GetWealth(i) > iTopScore)
         iTopScore = GetScore(i) + GetWealth(i);
    var szWinningPlayer = "";
    var szOtherWinningPlayers = "";
    for(var i = 0; i < GetPlayerCount(); i++) {
      if(GetScore(i) + GetWealth(i) == iTopScore) {
        if(szWinningPlayer ne "") {
          if(szOtherWinningPlayers ne "") {
            szOtherWinningPlayers = Format("%s, %s", szWinningPlayer, szOtherWinningPlayers);
          } else{
            szOtherWinningPlayers = szWinningPlayer;
          }
        }
        szWinningPlayer = GetPlayerName(i);
      }
    }
    if(szOtherWinningPlayers ne "") {
      DisplayMessage("PlayersWon", szWinningPlayer, szOtherWinningPlayers);
    } else {
      DisplayMessage("PlayerWon", szWinningPlayer);
    }
  }
  pCursor -> FadeOut();
  return(1);
}

func Script7() {
  for(var i = 0; i < GetPlayerCount(); i++) {
    // In diesem Szenario gibt's keinen (Punkte-)Gewinner.
    SetWealth(i, 0);
    DoScore(i, -GetScore(i));
  }
  return(GameOver());
}